#pragma once

#include <Text.h>

namespace Network
{
    namespace HTTP
    {
        class Answer : public virtual Framework::ReferenceCounter
        {
        private:
            Framework::Text protocol;
            int statusNumber;
            Framework::Text statusText;
            Framework::Text date;
            Framework::Text contentType;
            Framework::Text header;
            Framework::Text data;
            Framework::Text all;

        public:
            __declspec( dllexport ) Answer( const char *answer );

            __declspec( dllexport ) const char *getContentType() const;
            __declspec( dllexport ) const char *getData() const;
            __declspec( dllexport ) int getStatusCode() const;
            __declspec( dllexport ) const char *getStatusText() const;
            __declspec( dllexport ) const char *getDate() const;
            __declspec( dllexport ) const char *getAll() const;
        };

        class PostRequest : public virtual Framework::ReferenceCounter
        {
        private:
            Framework::Text path;
            Framework::Text host;
            Framework::Text contentType;
            Framework::Text data;
            unsigned short port;
            bool useSSL;

        public:
            __declspec( dllexport ) PostRequest( const char *path, const char *host, const char *data, const char *contentType, unsigned short port, bool useSSL = false );

            __declspec( dllexport ) Answer *execute() const;
        };
    }
}